# Setup

Clone the repository
and in the root directory
of the repo,
execute

```bash
cargo tauri icon assets/icon.svg
```

and write the Nextcloud token
into `src/server/cloud_user.txt`.

## Android

To enable android development,
additionally execute

```bash
rm gen/android/app/build.gradle.kts
NDK_HOME=<path> ANDROID_HOME=<path> cargo tauri android init
git restore gen/android/app/build.gradle.kts
```

and set up `gen/android/keystore.properties`,
e.g. following https://v2.tauri.app/distribute/sign/android/.

# Run

## Linux Development

Tauri does not seem to support
specifying the binary
to be run in a config,
so we have to do it
on the command line.

```bash
cargo tauri dev -- --bin tauri
```

## Android Development

Tauri does not seem to support
specifying the Cargo features
of the library for mobile
in a config,
so we have to do it
on the command line.

```bash
NDK_HOME=<path> ANDROID_HOME=<path> cargo tauri android dev --features tauri
```
