use serde::{Deserialize, Serialize};

/// An amount of cash,
/// measured as an integer multiple
/// of 0.01 €.
#[derive(Debug, Clone, Copy, PartialEq, Eq, Serialize, Deserialize)]
pub struct Cash(i64);

impl std::str::FromStr for Cash {
	type Err = ();

	fn from_str(s: &str) -> Result<Self, Self::Err> {
		let split: Vec<&str> = s.split(".").collect();
		let i = i64::from_str(split.get(0).ok_or(())?)
			.map_err(|e| println!("{:?}", e))?;
		let f = match split.get(1) {
			None => 0,
			Some(fs) => i64::from_str(&format!("00{}", fs)[0..2])
				.map_err(|e| println!("{:?}", e))?,
		};
		Ok(Cash(i * 100 + f))
	}
}