use serde::{Deserialize, Serialize};

mod store;
mod account;
mod cash;

pub use store::Store;
pub use account::Account;
pub use cash::Cash;

#[derive(Clone, Debug, Serialize, Deserialize)]
pub struct Inventory {
	pub acc: Account,
	pub cash: Cash,
	pub vouchers: Vec<VoucherInventory>,
}

#[derive(Clone, Copy, Debug, Serialize, Deserialize)]
pub struct VoucherInventory {
	pub store: Store,
	pub count: i64,
}
