use serde::{Deserialize, Serialize};

#[derive(Clone, Copy, Debug, Serialize, Deserialize)]
#[cfg_attr(feature = "server", derive(sqlx::Type))]
pub enum Store {
	Aldi,
	Edeka,
	Dm,
	Lidl,
	Rewe,
	Tegut,
}

impl Into<String> for &Store {
	fn into(self) -> String {
		String::from(match *self {
			Store::Aldi => "aldi",
			Store::Edeka => "edeka",
			Store::Dm => "dm",
			Store::Lidl => "lidl",
			Store::Rewe => "rewe",
			Store::Tegut => "tegut",
		})
	}
}

impl TryFrom<&str> for Store {
	type Error = ();

	fn try_from(s: &str) -> Result<Self, Self::Error> {
		match s {
			"aldi" => Ok(Store::Aldi),
			"edeka" => Ok(Store::Edeka),
			"dm" => Ok(Store::Dm),
			"lidl" => Ok(Store::Lidl),
			"rewe" => Ok(Store::Rewe),
			"tegut" => Ok(Store::Tegut),
			_ => Err(()),
		}
	}
}
